/**
* Wszystkie prawa zastrzeone.
* Autor: Tomasz Kaczanowski
* Licencja: Kod mona modyfikowa, oraz uy we wasnych rozwizaniach nieodpatnie,
* jedyny wymg - konieczno podania w dokumentacji informacji o wykorzystaniu kodu
* oraz autora - Tomasza Kaczanowskiego. Jeli jest jaka informacja o programie
* - rwnie tam naley umieci adekwatn informacj.
*/

#include "mydefaultobj.h"
#include <math.h>
#include <stdio.h>


struct TParseItem;

typedef double (*DoEvalue)(struct TParseItem *);
enum xoper {kpop_none = 0, kpop_add = 1, kpop_sub = 2, kpop_multi = 3, kpop_div = 4};


/* Klasy podstawowe */


/** Wirtualna klasa elementu*/
struct TParseItem
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    DoEvalue fooEvalue;

};

/** Kontener na elementy sparsowanych elementw */
struct TKacParser
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    struct TParseItem *FirstItem;
};



/** Klasy elementw */

struct TParseDValue
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    DoEvalue fooEvalue;
    double Value;
};

struct TParseLValue
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    DoEvalue fooEvalue;
    long int Value;
};

struct TParseCValue
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    DoEvalue fooEvalue;
    unsigned char kind;/**< 0 bd, 1 - PI, 2 - e, 3 - -PI, 4 - -e*/
};



struct TParseOperator
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    DoEvalue fooEvalue;
    enum xoper kind;
    struct TParseItem *PrevItem;
    struct TParseItem *NextItem;
};

struct TParseERR
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
    DoEvalue fooEvalue;
    int errnr;
};




void doPrintInfo(FILE *afout, struct TKacParser *aobj)
{
    ShowObjectInfo(afout, (struct TDefaultObj *)aobj);
}

void FreeParserObject(struct TKacParser *aobj)
{
    FreeDefaultObject((struct TDefaultObj *)aobj);
}
double doParserEvalue(struct TKacParser *aobj)
{
    double res = NAN;
    if (aobj)
    {
    	if (aobj->FirstItem)
        {
        	res = aobj->FirstItem->fooEvalue(aobj->FirstItem);
        }
    }
    return res;
}



/** definicje metod */

static size_t tpeGetSize(struct TDefaultObj *x)
{
    return sizeof(struct TParseERR);
}

static void tpeShowInfo(FILE *afout, struct TDefaultObj *x)
{
    struct TParseERR *lx = (struct TParseERR *)x;
    if (lx)
    {
        fprintf(afout, " [BD nr %d]", lx->errnr);
    }

}
static double tpeEvalue(struct TParseItem *x)
{
    return NAN;
}



static struct TParseERR *CreateParseErr(int aerr)
{
    struct TParseERR *res = (struct TParseERR *)malloc(sizeof(struct TParseERR));
    if (res)
    {
        res->errnr = aerr;
        res->fooDestructor = NULL;
		res->fooGetSize = tpeGetSize;
		res->fooCloneObj = NULL;
        res->fooShowObjInfo = tpeShowInfo;
    	res->fooEvalue = tpeEvalue;
	}
    return res;
}

static struct TParseItem *FindNumber(const char *buf);




static void TKacParserDestructor(struct TDefaultObj *aobj)
{
    struct TKacParser *x = (struct TKacParser *)aobj;
    if (x)
    {
        if (x->FirstItem)
        	FreeDefaultObject((struct TDefaultObj *)x->FirstItem);
        x->FirstItem = NULL;
        free(x);
    }
}

static struct TDefaultObj *TKacParserClone(struct TDefaultObj *aobj)
{
    struct TKacParser *x = (struct TKacParser *)aobj;
    struct TKacParser *res = NULL;
    if (x)
    {
        res = (struct TKacParser *)malloc(sizeof(struct TKacParser));
        memcpy(res, x, sizeof(struct TKacParser));
        if (x->FirstItem)
        {
        	res->FirstItem = (struct TParseItem *)CloneDefaultObject((struct TDefaultObj *)x->FirstItem);
    	}
        else
        	res->FirstItem = NULL;

    }
    return (struct TDefaultObj *)res;
}

static void TKacParserShowInfo(FILE *afout, struct TDefaultObj *x)
{
    struct TKacParser *lx = (struct TKacParser *)x;
    if (lx)
    {
    	if (lx->FirstItem)
        	lx->FirstItem->fooShowObjInfo(afout, (struct TDefaultObj *)lx->FirstItem);
    }

}

/** Konstruktor klasy kontenera*/
struct TKacParser *doPreParse(const char *buf)
{
    struct TKacParser *res = (struct TKacParser *)malloc(sizeof(struct TKacParser));

    if (res)
    {
    	res->fooDestructor = TKacParserDestructor;
        res->fooGetSize = NULL;
        res->fooCloneObj = TKacParserClone;
        res->fooShowObjInfo = TKacParserShowInfo;
        res->FirstItem = FindNumber(buf);
	}



    return res;
}







static size_t tpcvGetSize(struct TDefaultObj *x)
{
    return sizeof(struct TParseCValue);
}
static const char *tpcv_arr[] = {"ERR", "PI", "E", "-PI", "-E"};
static double tpcvarr[] = {0, M_PI, M_E, -M_PI, -M_E};

static void tpcvShowInfo(FILE *afout, struct TDefaultObj *x)
{
    struct TParseCValue *lx = (struct TParseCValue *)x;
    if (lx)
    {
        if (lx->kind < 5)
        	fprintf(afout, " %s", tpcv_arr[lx->kind]);
    }

}
static double tpcvEvalue(struct TParseItem *x)
{
    struct TParseCValue *lx = (struct TParseCValue *)x;
    double res = NAN;
    if (lx)
    {
        if (lx->kind < 5)
        	res = tpcvarr[lx->kind];
	}
    return res;
}


static struct TParseCValue *CreateCValue(const char *buf)
{
    struct TParseCValue *res = (struct TParseCValue *)malloc(sizeof(struct TParseCValue));
    if (res)
    {
        res->kind = 0;
        if (strcmp("PI", buf) == 0)
        	res->kind = 1;
        else if (strcmp("-PI", buf) == 0)
        {
            res->kind = 3;
    	}
        else if (strcmp("E", buf) == 0)
        {
            res->kind = 2;
    	}
        else if (strcmp("-E", buf) == 0)
        {
            res->kind = 4;
        }
        res->fooDestructor = NULL;
		res->fooGetSize = tpcvGetSize;
		res->fooCloneObj = NULL;
    	res->fooShowObjInfo = tpcvShowInfo;
    	res->fooEvalue = tpcvEvalue;

    }
    return res;

}
static size_t tpdvGetSize(struct TDefaultObj *x)
{
    return sizeof(struct TParseDValue);
}

static void tpdvShowInfo(FILE *afout, struct TDefaultObj *x)
{
    struct TParseDValue *lx = (struct TParseDValue *)x;
    if (lx)
    {
    	fprintf(afout, " %f", lx->Value);
    }

}
static double tpdvEvalue(struct TParseItem *x)
{
    struct TParseDValue *lx = (struct TParseDValue *)x;
    double res = NAN;
    if (lx)
    {
        res = lx->Value;
	}
    return res;
}


static struct TParseDValue *CreateDValue(const char *buf)
{
    struct TParseDValue *res = (struct TParseDValue *)malloc(sizeof(struct TParseDValue));
    if (res)
    {
        res->Value = strtod(buf, NULL);
        res->fooDestructor = NULL;
		res->fooGetSize = tpdvGetSize;
		res->fooCloneObj = NULL;
        res->fooShowObjInfo = tpdvShowInfo;
    	res->fooEvalue = tpdvEvalue;
	}
    return res;
}

static size_t tplvGetSize(struct TDefaultObj *x)
{
    return sizeof(struct TParseLValue);
}

static void tplvShowInfo(FILE *afout, struct TDefaultObj *x)
{
    struct TParseLValue *lx = (struct TParseLValue *)x;
    if (lx)
    {
    	fprintf(afout, " %d", lx->Value);
    }

}

static double tplvEvalue(struct TParseItem *x)
{
    struct TParseLValue *lx = (struct TParseLValue *)x;
    double res = NAN;
    if (lx)
    {
        res = lx->Value;
	}
    return res;
}


static struct TParseLValue *CreateLValue(const char *buf)
{
    struct TParseLValue *res = (struct TParseLValue *)malloc(sizeof(struct TParseLValue));
    if (res)
    {
        res->Value = strtol(buf, NULL);
        res->fooDestructor = NULL;
		res->fooGetSize = tplvGetSize;
		res->fooCloneObj = NULL;
        res->fooShowObjInfo = tplvShowInfo;
    	res->fooEvalue = tplvEvalue;
	}
    return res;
}

static void tpoDestructor(struct TDefaultObj *aobj)
{
    struct TParseOperator *x = (struct TParseOperator *)aobj;
    if (x)
    {
        if (x->PrevItem)
        	FreeDefaultObject((struct TDefaultObj *)x->PrevItem);
        x->PrevItem = NULL;
        if (x->NextItem)
        	FreeDefaultObject((struct TDefaultObj *)x->NextItem);
        x->NextItem = NULL;
        free(x);
    }
}
static struct TDefaultObj *tpoClone(struct TDefaultObj *aobj)
{
    struct TParseOperator *x = (struct TParseOperator *)aobj;
    struct TParseOperator *res = NULL;
    if (x)
    {
        res = (struct TParseOperator *)malloc(sizeof(struct TParseOperator));
        memcpy(res, x, sizeof(struct TParseOperator));
        if (x->PrevItem)
        {
        	res->PrevItem = (struct TParseItem *)CloneDefaultObject((struct TDefaultObj *)x->PrevItem);
    	}
        else
        	res->PrevItem = NULL;
        if (x->NextItem)
        {
        	res->NextItem = (struct TParseItem *)CloneDefaultObject((struct TDefaultObj *)x->NextItem);
    	}
        else
        	res->NextItem = NULL;

    }
    return (struct TDefaultObj *)res;
}

static const char ctpoop[] = {'?', '+', '-', '*', '/'};



static void tpoShowInfo(FILE *afout, struct TDefaultObj *x)
{
    struct TParseOperator *lx = (struct TParseOperator *)x;
    if (lx)
    {
        if (lx->PrevItem)
        	ShowObjectInfo(afout, (struct TDefaultObj *)lx->PrevItem);
        fprintf(afout, " %c", ctpoop[(int)lx->kind]);
        if (lx->NextItem)
        	ShowObjectInfo(afout, (struct TDefaultObj *)lx->NextItem);
    }

}
static double tpoEvalue(struct TParseItem *x)
{
    struct TParseOperator *lx = (struct TParseOperator *)x;
    double res = NAN, a, b;
    if (lx)
    {
        if (lx->PrevItem && lx->NextItem)
        {

            a = lx->PrevItem->fooEvalue(lx->PrevItem);
            b = lx->NextItem->fooEvalue(lx->NextItem);
            switch (lx->kind)
            {
            	case kpop_add:
                     res = a + b;
                	break;
                case kpop_sub:
                     res = a - b;
                	break;
                case kpop_multi:
                     res = a * b;
                	break;
                case kpop_div:
                     res = a / b;
                	break;

            }
        }
    }
    return res;
}


static struct TParseItem *FindOperator(const char *buf, struct TParseItem *afirst)
{
    char *pact = (char *)buf;
    struct TParseOperator *res = NULL;
    int lxend = 0;
    enum xoper lkind = kpop_none;
    while ((*pact) && pact && (lxend == 0))
    {
        switch (*pact)
        {
            case 32:
            case 160:
            case '\n':
            case '\r':
            case '\t':
                  	++pact;//znaki wiodce
                	break;
            case '+':
                lkind = kpop_add;
                lxend = 1;
                ++pact;
                break;
            case '-':
                lkind = kpop_sub;
                lxend = 2;
                ++pact;
                break;
            case '*':
                lkind = kpop_multi;
                lxend = 3;
                ++pact;
                break;
            case '/':
                lkind = kpop_div;
                lxend = 4;
                ++pact;
                break;
            default:
            	lxend = -1;
                break;
        }


    }
    if (lxend > 0)
    {
        res = (struct TParseOperator *)malloc(sizeof(struct TParseOperator));
        if (res)
        {
            res->kind = lkind;
            res->fooDestructor = tpoDestructor;
    		res->fooGetSize = NULL;
    		res->fooCloneObj = tpoClone;
            res->fooShowObjInfo = tpoShowInfo;
        	res->fooEvalue = tpoEvalue;
            res->PrevItem = afirst;
            res->NextItem = FindNumber(pact);
        }
    }
    else if (lxend < 0)
    {
        res = (struct TParseOperator *)malloc(sizeof(struct TParseOperator));
        if (res)
        {
            res->kind = lkind;
            res->fooDestructor = tpoDestructor;
    		res->fooGetSize = NULL;
    		res->fooCloneObj = tpoClone;
            res->fooShowObjInfo = tpoShowInfo;
        	res->fooEvalue = tpoEvalue;
            res->PrevItem = afirst;
            res->NextItem = (struct TParseItem *)CreateParseErr(1);
        }
    }
    else
    {
        res = (struct TParseOperator *)afirst;  //dalej tylko puste znaki, wiec zwracamy liczbe
    }

    return (struct TParseItem *)res;
}

static struct TParseItem *FindNumber(const char *buf)
{
    struct TParseItem *res = NULL , *lpitm = NULL;
    char *pact = (char *)buf;
    char xarr[128];
    unsigned int b = 0;//bit 1 - by znak, bit 2 - byy cyfry, bit 3 - byy litery, bit 4 - by przecinek/kropka
    int i = 0;
    int lxend = 0;
    while ((*pact) && pact && (lxend == 0))
    {
    	switch (*pact)
       	{
       		case 32:
            case 160:
            case '\n':
            case '\r':
            case '\t':
            	if ((i == 0) || ((i == 1) && (b == 1)))
                {
                  	++pact;//znaki wiodce
                }
                else
                {
                   lxend = 1;
                   ++pact;
                }


        		break;
            case '-':
            case '+':
                if (i == 0)
                {
                   xarr[i] = *pact;
                   ++pact;
                   ++i;
                   b = 1;
            	}
                else
                {
                    lxend = 2;
                }

                break;
            case '.':
            case ',':
                if ((b & (4 + 8)) == 0)
                {
                    if (i == 0)
                    {
                       xarr[0] = '0';
                       ++i;
                    }
                    xarr[i] = '.';
                    b |= 8;
                    ++i;
                    ++pact;
            	}
                else
                {
                    lxend = -1;//bad - 2 razy 'kropka' w liczbie
                }
                break;

       		default:
            	if (((*pact) >= '0') && ((*pact) <= '9'))
                {
                    if ((b & 4) == 0)
                    {
                        xarr[i] = *pact;
                        ++i;
                        ++pact;
                        b |= 2;
                    }
                    else
                    {
                        lxend = -2;
                    }

            	}
                else if ((((*pact) >= 'a') && ((*pact) <= 'z')) || (((*pact) >= 'A') && ((*pact) <= 'Z')))
                {
                   if ((b & 2) == 0)
                    {
                        xarr[i] = toupper(*pact);
                        ++i;
                        ++pact;
                        b |= 4;
                    }
                	else
                    {
                        lxend = -3;
                    }

        		}
                else
                	lxend = 3;
                break;

       	};

    }
    if  ( (i > 0) && ((b & (4 + 2)) > 0) && ((lxend > 0) || (((*pact) == 0) && (lxend == 0))))
    {

        xarr[i] = 0;//terminujemy cig
        if ((b & 4) > 0)
        {
            lpitm = (struct TParseItem *)CreateCValue(xarr);
        }
        else if ((b & 8) > 0)
        {
            lpitm = (struct TParseItem *)CreateDValue(xarr);
    	}
        else
        {
        	lpitm  = (struct TParseItem *)CreateLValue(xarr);
        }


   		if ((*pact) == 0)
        {
            res = lpitm;
        }
        else
        {
        	res = FindOperator(pact, lpitm);

        }


	}
    else if (((*pact) == 0) && (i == 0) && (lxend == 0))   // zwrci null
    {

    }

    else
    {

        res = (struct TParseItem *)CreateParseErr(100 + lxend);
        //obiekt bd
    }

   
    return res;

}


